<template>
  <div id="container">
    <div id="mapContainer" />
  </div>
</template>

<script>
import 'leaflet/dist/leaflet.css'
import L from 'leaflet'
import img from '../assets/images/3D-Icons-location.gif'
import axios from 'axios'
import { BASE_URL } from '../tools/constant.js'

export default {
  name: 'Map',
  data () {
    return {
      defaultClick: false,
      labData: [],
      startlat: 30.28552,
      startlon: 114.15769,
      map: null,
      logLatArr: [],
      langLatData: [],
      hubIcon: L.icon({
        iconUrl: img,
        iconSize: [40, 40]
      }),
      hubData: [],
      hubData2: [],
      attraction: {
        name: '',
        address: '',
        category: ''
      },
      clientSecret: 'FTZGMLOIQWFY3A0ELEZIZSUU3M4EKOJKEPXKWUWTMWK1EY4H',
      clientID: 'GOSFGAOZKCSLMWADY1ORYJV2A4GUNNHAHBVWY500S1IM42CS'
    }
  },
  mounted () {
    this.setupLeafletMap()
    this.getLabs()
  },
  methods: {
    async getLabs (data) {
      let url = BASE_URL + '/getLab'
      axios({
        method: 'GET',
        url: url,
        headers: {
          'Content-Type': 'application/json'
        }
      }).then(res => {
        this.labData = res.data
        this.drawMap()
      }, error => {
        if (error) {
          this.$parent.errorMessage(this.$t(error.response.data))
        }
      })
    },
    setupLeafletMap () {
      this.map = L.map('mapContainer').setView([this.startlat, this.startlon], 4)
      L.tileLayer(
        'https://{s}.basemaps.cartocdn.com/light_all/{z}/{x}/{y}{r}.png?access_token={accessToken}',
        {
          attribution: 'OSM',
          maxZoom: 18,
          id: 'mapbox/streets-v11',
          accessToken:
            'pk.eyJ1IjoiYWJpZGlzaGFqaWEiLCJhIjoiY2l3aDFiMG96MDB4eDJva2l6czN3MDN0ZSJ9.p9SUzPUBrCbH7RQLZ4W4lQ'
        }
      ).addTo(this.map)
    },
    drawMap () {
      this.logLatArr = []
      for (var i = 0; i < this.labData.length; i++) {
        var zipCode = this.labData[i].pinCode
        var siteLocation = this.labData[i].city
        var fullAddress = zipCode + ',' + siteLocation
        var siteData = this.labData[i]
        this.getLongLat(fullAddress, siteData)
      }
    },
    getLongLat (paramsObj, siteData) {
      let dataRet = []
      axios.get('https://nominatim.openstreetmap.org/search?format=json&limit=3&q=' + paramsObj).then(response => {
        dataRet.push(response.data)
        this.drawIconHub(response.data, siteData)
      })
    },
    drawIconHub (myArr, sitesData) {
      var hubMarker = L.marker([myArr[0].lat, myArr[0].lon], { icon: this.hubIcon })
      hubMarker.bindTooltip(sitesData.labName, { permanent: true, direction: 'bottom', offset: [0, 30] })
      var template = `<div id="popup-div">\
        <table style="font-size:1em">\
          <tr style="font-size:1em">\
            <th style="font-size:1em" colspan="2">Details:</th>\
          </tr>\
          <tr style="font-size:1em">\
          <th style="font-size:1em">Labname:</th>\
          <td style="font-size:1em"> ${sitesData.labName}</td>\
        </tr>\
          <tr style="font-size:1em">\
            <th style="font-size:1em">Location:</th>\
            <td style="font-size:1em">${sitesData.city}</td>\
          </tr>\
          <tr style="font-size:1em">\
            <th style="font-size:1em">Zip code:</th>\
            <td style="font-size:1em">${sitesData.pinCode}</td>\
          </tr>\
          </table>\
      </div>`
      hubMarker.bindPopup(template).openPopup()
      hubMarker.addTo(this.map)
      hubMarker.on('click', this.getChange.bind(this, sitesData))
      if (!this.defaultClick) {
        this.defaultClick = true
        hubMarker.fire('click')
      }
    },
    getChange (val) {
      this.$emit('getLabInfo', val)
    }
  }
}
</script>

<style scoped>
#container {
  display: flex;
}
#info {
  width: 18vw;
}
#mapContainer {
  width: 80vw;
}
</style>
